/*		Name:		misc.c
		Version:	0.0.12
		Date:		11/7/2001
		Misc functions mainly hex and binary conversions
*/
#include <glib.h>
#include <ctype.h>
#include "misc.h"
#define uchar unsigned char


char* view_chararr2asciistr(int count, uchar* values)
{
  char* ret = g_new(char, count+1);  /* convert bit array into ASCII string*/
  int ptr=0;
  while (ptr<count){
    ret[ptr]=values[ptr];
    if (ret[ptr] < 0x10 /*|| ret[ptr] > 126*/) ret[ptr]='.';
    ptr++;
    }
	ret[ptr]='\0';
  return ret;                              /* Must g_free result*/
}

uchar* view_chararrAddint(int count, uchar* values,int toadd)
{
  uchar* ret = g_new(uchar, count);       /*bit array + int => bitarray */
  int ptr=0;
  int current;
  while (count--){
  
    current = values[ptr] + (toadd &255);
	ret[ptr] = current;
    ptr++;
	toadd = toadd>>8;
	if (current>255) toadd++;
    }
  return ret;                              /* Must g_free result*/
}

void view_chararrAddintsame(int count, uchar* values,int toadd)
{
  int ptr=0;
  int current;
  while (count--){       /*bit array + int => bitarray */
    current = values[ptr] + (toadd &255);
	values[ptr++] = current;
	toadd = toadd>>8;
	if (current>255) toadd++;     /* overwrites original value*/
    }
}

uchar* view_chararrAddchararr(int count, uchar* value1,uchar* value2)
{
  uchar* ret = g_new0(uchar,count);  /*bit array + bit array => bit array */
  uchar* ret2 = ret;
  int carry=0;
  while (count--){
    *(ret++) = *value1 + *value2 + carry;
    if (((int) *(value1++) + *(value2++) + carry)>0xff) carry = 1;
    else carry=0;
    }
  return ret2;                              /* Must g_free result*/
}

int view_chararrSubchararr(int count, uchar* value1, uchar* value2)
{
  int ret=0;  /*bit array - bit array => int */
  while (count--) ret = (ret<<8) + value1[count]-value2[count];
  return ret;
}

long view_chararrSublong (int count, uchar* value1, long value2)
{
  while (count--) value2 -= value1[count]<<(count<<3);
  return value2;    /*bit array - long => long */
}

int view_chararr2int(int count, uchar* value1)
{
  int ret=0;  /*bit array =>int */
  while (count--) ret = (ret<<8) + (value1[count]&0xff);
  return ret;
}

long view_chararr2long(int count, uchar* value1)
{
  long ret=0;  /*bit array =>int */
  while (count--) ret = (ret<<8) + (value1[count]&0xff);
  return ret;
}


uchar* view_int2chararr(int count, int value)
{
 uchar* ret = g_new(uchar, count);
 uchar* c=ret;
 while(count--){    /*int => bit array */
    *c=value & 0xff;
    value = value>>8;
    c++;
    }
  return ret;

}

void view_chararrCpychararr(int count, uchar* pass , uchar* ret)
{
  while (count--) ret[count]=pass[count];/* copy bit array */
}                                        /* must malloc destination*/


int view_findstrinarr(char* string, char** array,int arrcount)
{
  char* mystr = g_strdup(string);  /*find string in an array of strings and return position*/
  int temp1=0 ,temp2=0;
  while (mystr[temp1]) if (' ' == mystr[temp1]) temp1++;
                       else mystr[temp2++] = mystr[temp1++];
  mystr[temp2]='\0';
  while (arrcount--){
	if (!g_strcasecmp(mystr,array[arrcount])) break;
    }
  g_free(mystr);
  return arrcount;
}


void g_list_free_contents (GList* list)
{
 while (list){
    g_free(list->data);
    list = list->next;
    }
}



